Subject: bug#54751: Parted 3.4 complains about the partition layout of ChromeOS: "Can't have overlapping partitions"

From: "Brian C. Lane" <[email-masked]>
Date: Wed, 6 Apr 2022 16:03:40 -0700

On Thu, Apr 07, 2022 at 06:19:02AM +0800, Steven Shiau wrote:
> 
> On 4/7/22 00:27, Brian C. Lane wrote:
> > On Wed, Apr 06, 2022 at 02:20:56PM +0800, Steven Shiau wrote:
> >
> >> So my questions: (1) Is there any option we can use to ignore the
> >> error/warning in the script mode? (2) What is the issue about the
> >> partition layout of ChromeOS? Thank you very much.
> > No, having overlapping partitions is an error, and script mode tries
> > pretty hard to make sure you can't accidentally destroy your data.
> >
> > Please include the output from
> >
> > parted /dev/sda unit s print
> >
> > so we can see what parted thinks the sector locations and lengths are.
> >
> > Brian
> >
> Thank you very much for answering this. Here you are:
> root@debian:~# parted /dev/sda unit s print
> Error: Can't have overlapping partitions.
> Ignore/Cancel? I
> Model: VMware Virtual Storage (scsi)
> Disk /dev/sda: 25165824s
> Sector size (logical/physical): 512B/512B
> Partition Table: gpt
> Disk Flags: pmbr_boot
> 
> Number  Start     End        Size      File system  Name        Flags
> 11      64s       64s        1s                     RWFW
>   6      65s       65s        1s                     KERN-C      chromeos_kernel
>   7      66s       66s        1s                     ROOT-C
>   9      67s       67s        1s                     reserved
> 10      68s       68s        1s                     reserved
>   2      69s       32836s     32768s                 KERN-A      chromeos_kernel
>   4      32837s    65604s     32768s                 KERN-B      chromeos_kernel
>   8      69632s    102399s    32768s    ext4         OEM
> 12      102400s   233471s    131072s   fat16        EFI-SYSTEM  boot, legacy_boot, esp
>   5      233472s   237567s    4096s                  ROOT-B
>   3      237568s   5152767s   4915200s  ext2         ROOT-A
>   1      5152768s  13553792s  8401025s  ext4         STATE

It looks like parted doesn't like 1 sector partitions that aren't in
order. I can reproduce this by making them at 64s, 66s, then 65s. But if
I make 64s, 65s, 66s it is happy with it, even when printing it later.

I'll look into it more when I have a chance, but I think this is a
corner case that has been there quite a while so it won't make it into
the pending 3.5 release.

Thanks,

Brian

-- 
Brian C. Lane (PST8PDT) - weldr.io - lorax - parted - pykickstart